config/routes.rb
Rails.application.routes.draw do
  resources :client_measure_histories
  resources :training_clients
  resources :repetitions
  resources :numbers
  resources :exercises
  resources :equipaments
  resources :client_payment_histories
  resources :clients
  #resources :plan_service_clients
  resources :service_clients
  resources :plan_clients
  resources :gym_payment_histories
  resources :coaches
  resources :gyms
  #resources :plan_service_managers
  resources :service_managers
  resources :plan_managers
  resources :managers
  resources :admins

  root to: 'application#home'

  devise_for :users, path: '', path_names: { sign_in: 'login', sign_out: 'logout', sign_up: 'register', edit: 'settings' }
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

  get '/home', to: 'application#home', as: 'home'
  get '/secret', to: 'application#secret', as: 'secret'

  get '/manager_clients', to: 'managers#show_clients'
  get '/manager_coaches', to: 'managers#show_coaches'

  get '/admin_managers', to: 'admins#show_managers'
  get '/admin_managers/:email', to: 'admins#show_manager'
  get '/gym_payments/:id',  to: 'gyms#payments'

  # token auth routes available at /api_application/mobile/auth
  namespace :api_application do
    scope :mobile do
      mount_devise_token_auth_for 'UserMobile', at: 'auth'
    end
  end

  devise_scope :user_mobile do
    get 'api_application/mobile/mobile_profile', to: 'mobile#mobile_profile'
    get 'api_application/mobile/profile_payments', to: 'mobile#profile_payments'
    get 'api_application/mobile/profile_training', to: 'mobile#profile_training'
    get 'api_application/mobile/profile_measures', to: 'mobile#profile_measures'

  end

end

app/models/admin.rb
class Admin < ApplicationRecord
  belongs_to :user
end

app/models/client.rb
class Client < ApplicationRecord
  belongs_to :user
  belongs_to :gym
  belongs_to :plan_client

  has_many :client_payment_histories
  has_many :training_clients
  has_many :client_measure_histories
end

app/models/coach.rb
class Coach < ApplicationRecord
  belongs_to :user
  belongs_to :gym

  has_many :trainings
end

app/models/equipament.rb
class Equipament < ApplicationRecord
  belongs_to :gym

  has_many :trainings
end

app/models/exercise.rb
class Exercise < ApplicationRecord
  belongs_to :gym

  has_many :trainings

end

app/models/gym.rb
class Gym < ApplicationRecord
  belongs_to :manager
  belongs_to :plan_manager

  has_many :coaches
  has_many :gym_payment_histories
  has_many :clients
  has_many :service_clients
  has_many :equipaments
  has_many :exercises
  has_many :numbers
  has_many :repetitions

end

app/models/gym_payment_history.rb
class GymPaymentHistory < ApplicationRecord
  belongs_to :gym
end

app/models/manager.rb
class Manager < ApplicationRecord
  belongs_to :user
  has_many :gyms
end

app/models/measure.rb
class Measure < ApplicationRecord
  has_many :client_measure_histories
end

app/models/muscle_type.rb
class MuscleType < ApplicationRecord

  has_many :trainings

end

app/models/number.rb
class Number < ApplicationRecord
  belongs_to :gym

  has_many :trainings

end

app/models/plan_client.rb
class PlanClient < ApplicationRecord
  belongs_to :gym

  has_many :plan_service_clients
  has_many :clients

end

app/models/plan_manager.rb
class PlanManager < ApplicationRecord
  has_many :plan_service_managers
  has_one :gym
end

app/models/repetition.rb
class Repetition < ApplicationRecord
  belongs_to :gym

  has_many :trainings

end

app/models/service_client.rb
class ServiceClient < ApplicationRecord
  belongs_to :gym
  has_many :plan_service_clients
end

app/models/training.rb
class Training < ApplicationRecord
  belongs_to :coach
  belongs_to :equipament
  belongs_to :exercise
  belongs_to :number
  belongs_to :repetition
  belongs_to :muscle_type
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable

  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable


  has_many :admis
  has_many :Managers
  has_many :coaches
  has_many :clients
end

app/models/user_mobile.rb
class UserMobile < ActiveRecord::Base
  # Include default devise modules.
  devise :database_authenticatable, :registerable,
          :recoverable, :rememberable, :trackable, :validatable,
          #:confirmable,
          :omniauthable
  include DeviseTokenAuth::Concerns::User

  def self.is_valid_token(token, client_id)
    @resource.valid_token?(token, client_id)
  end

end

app/controllers/gym_payment_histories_controller.rb
class GymPaymentHistoriesController < ApplicationController
  before_action :set_gym_payment_history, only: [:show, :edit, :update, :destroy]
  before_action :manager_block_acess, except: [:index, :show]
  before_action :authenticate_user!

  # GET /gym_payment_histories
  # GET /gym_payment_histories.json
  def index
    if current_user
      @admin = Admin.find_by_user_id(current_user)
      @manager = Manager.find_by_user_id(current_user)

      if @admin
        @gym_payment_histories = GymPaymentHistory.order("payment_date DESC").all
      elsif @manager
        @gym = Gym.find_by_manager_id(@manager)
        @gym_payment_histories = GymPaymentHistory.where(:gym_id => @gym ).order("payment_date DESC").all
      end

    end

  end

  # GET /gym_payment_histories/1
  # GET /gym_payment_histories/1.json
  def show
  end

  # GET /gym_payment_histories/new
  def new
    @gym_payment_history = GymPaymentHistory.new
    @gyms = Gym.all
  end

  # GET /gym_payment_histories/1/edit
  def edit
  end

  # POST /gym_payment_histories
  # POST /gym_payment_histories.json
  def create
    @gym_payment_history = GymPaymentHistory.new(gym_payment_history_params)

    if @gym_payment_history.save
      redirect_to gym_payment_histories_path, notice: 'Pagamento efetuado com sucesso'
    else
      redirect_to gym_payment_histories_path, notice: 'Pagamento efetuado com sucesso'
    end
  end

  # PATCH/PUT /gym_payment_histories/1
  # PATCH/PUT /gym_payment_histories/1.json
  def update
    respond_to do |format|
      if @gym_payment_history.update(gym_payment_history_params)
        format.html { redirect_to @gym_payment_history, notice: 'Gym payment history was successfully updated.' }
        format.json { render :show, status: :ok, location: @gym_payment_history }
      else
        format.html { render :edit }
        format.json { render json: @gym_payment_history.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /gym_payment_histories/1
  # DELETE /gym_payment_histories/1.json
  def destroy
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_gym_payment_history
      @gym_payment_history = GymPaymentHistory.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def gym_payment_history_params
      params.require(:gym_payment_history).permit(:gym_id, :price, :payment_date)
    end
end

app/helpers/admins_helper.rb
module AdminsHelper
end

app/helpers/gym_payment_histories_helper.rb
module GymPaymentHistoriesHelper
end

app/helpers/gyms_helper.rb
module GymsHelper
end

app/helpers/mobile_helper.rb
module MobileHelper
end

app/views/gym_payment_histories/_form.html.erb
<form action="/gym_payment_histories" accept-charset="UTF-8" method="post">
  <div class="form-group">
    <label for="gym_payment_history_gym_id">Academia</label>
    <select class="form-control" id="gym_payment_history_gym_id" name="gym_payment_history[gym_id]">
      <% @gyms.each do |g| %>
        <option value = <%= g.id %> > Academia:<%= g.name %> || Valor: <%= g.plan_manager.price %>  || Gerente: <%= g.manager.user.email%> </option>
      <% end %>
    </select>
  </div>
  <div class="form-group">
    <label for="gym_payment_history_price">Valor pago</label>
    <input type="text" class="form-control" autofocus="autofocus" name="gym_payment_history[price]" id="gym_payment_history_price">
  </div>
  <div class="form-group">
    <label for="gym_payment_history_payment_date" class="col-2 col-form-label">Date</label>
    <input class="form-control" type="date" name="gym_payment_history[payment_date]" id="gym_payment_history_payment_date">
  </div>
  </br>
  <button type="submit" class="btn btn-primary" name="commit" value="Create Gym payment history" data-disable-with="Create Gym payment history"/>Cadastrar</button>
</form>

app/views/gym_payment_histories/edit.html.erb
<h1>Editing Gym Payment History</h1>

<%= render 'form', gym_payment_history: @gym_payment_history %>

<%= link_to 'Show', @gym_payment_history %> |
<%= link_to 'Back', gym_payment_histories_path %>

app/views/gym_payment_histories/index.html.erb
<div class="content-wrapper">
  <!-- Content Header (Page header) -->
  <section class="content-header">
    <ol class="breadcrumb">
      <li><a href="/"><i class="fa fa-dashboard"></i>Home</a></li>
      <li class="active">histórico de pagamento</li>
    </ol>
  </section>

    <div class="row">
      <section class="col-lg-12 connectedSortable">
        <table class="table table-hover">
          <thead>
            <tr>
              <% if @admin%>
              <th>Academia</th>
              <% end %>
              <th>Vencimento</th>
              <th>Valor Pago</th>
              <th>Desconto</th>
              <th>Dia do pagamento</th>
              <th colspan="6"></th>
            </tr>
          </thead>

          <tbody>
            <% @gym_payment_histories.each do |gym_payment_history| %>
              <tr>
                <% if @admin%>
                <td><%= gym_payment_history.gym.name %></td>
                <% end %>
                <td><%= gym_payment_history.gym.plan_manager.price %></td>
                <td><%= gym_payment_history.price %></td>
                <td><%= gym_payment_history.gym.plan_manager.price - gym_payment_history.price %></td>
                <td><%= gym_payment_history.payment_date.strftime("%d/%m/%Y") %></td>
                <% if @admin%>
                <td><%= link_to 'Edit', edit_gym_payment_history_path(gym_payment_history) %></td>
                <% end %>
              </tr>
            <% end %>
          </tbody>
        </table>

      </section>
    </div>

    <% if @admin%>
      <div class="row">
        <div class="col-lg-offset-5 col-lg-2">
          <a href="/gym_payment_histories/new" class="btn btn-primary" role="button">Novo Pagamento</a>
        </div>
      </div>
    <% end %>

  </section>
</div>
</div>
<!-- ./wrapper -->

app/views/gym_payment_histories/new.html.erb
<div class="text-center"> <p class="text-primary"> <h3>Realizar novo pagamento</h3></p> </div>
<br/>
<div class="row">
  <div class="col-lg-6">
    <%= render 'form', gym_payment_history: @gym_payment_history %>
  </div>

</div>

app/views/gym_payment_histories/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Gym:</strong>
  <%= @gym_payment_history.gym %>
</p>

<p>
  <strong>Price:</strong>
  <%= @gym_payment_history.price %>
</p>

<p>
  <strong>Payment date:</strong>
  <%= @gym_payment_history.payment_date %>
</p>

<%= link_to 'Edit', edit_gym_payment_history_path(@gym_payment_history) %> |
<%= link_to 'Back', gym_payment_histories_path %>